<?php
// $Id: taxonomy_theme_pathes.inc,v 1.4 2006/10/20 07:42:28 profix898 Exp $

/**
 * function _taxonomy_theme_select_pathes().
 * (assign theme to Drupal pathes and path aliases (incl. i18n support))
 */
function _taxonomy_theme_select_pathes(&$custom_theme, $uri) {
  $offset  = (variable_get('clean_url', 0) ? 0 : 3) + strlen(base_path());
  $alias_uri = substr(request_uri(), $offset);
  if (module_exists('i18n')) {
    i18n_get_lang_prefix($alias_uri, true);
  }
  $alias_uri = $alias_uri ? $alias_uri : '/';
  $themes = list_themes();
  foreach ($themes as $themex) {
    $pathes_regexp = _taxonomy_theme_expcache($themex->name);
    if (preg_grep($pathes_regexp, array($uri, $alias_uri))) {
      $custom_theme = $themex->name;
    }
  }
}

/**
 * function _taxonomy_theme_expcache().
 * (build cacheable regexps from from pathes table)
 */
function _taxonomy_theme_expcache($theme_name = NULL) {
  static $cache;
  if (!$theme_name) {
    $cache = array();
    return;
  }
  // build new regexps from table and put them into cache
  if (!isset($cache[$theme_name])) {
    $result = db_query("SELECT path FROM {theme_pathes} WHERE theme = '%s'", $theme_name);
    if (db_num_rows($result)) {
      while ($path = db_fetch_object($result)) {
        $pathes .= empty($pathes) ? '' : '|';
        $pathes .= str_replace(array('*', '/'), array('.*', '\/'), drupal_get_normal_path($path->path));
      }
    }
    $cache[$theme_name] = '/^('.$pathes.')$/';
  }
  
  return $cache[$theme_name];
}

?>
